diff --git a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
index 1ff5af05f..790e9c36f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
+++ b/game/core/src/main/java/net/minecraft/core/block/tag/BlockTags.java
@@ -1,17 +1,17 @@
 package net.minecraft.core.block.tag;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.block.BlockLogicCactus;
+import net.minecraft.core.block.BlockLogicFence;
+import net.minecraft.core.block.BlockLogicFenceChainlink;
+import net.minecraft.core.block.BlockLogicFlower;
+import net.minecraft.core.block.BlockLogicFire;
+import net.minecraft.core.block.BlockLogicFluid;
+import net.minecraft.core.block.BlockLogicLanternFirefly;
+import net.minecraft.core.block.BlockLogicJar;
+import net.minecraft.core.block.BlockLogicSugarcane;
+import net.minecraft.core.block.BlockLogicTallGrass;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockCactus;
-import net.minecraft.core.block.BlockFence;
-import net.minecraft.core.block.BlockFenceChainlink;
-import net.minecraft.core.block.BlockFlower;
-import net.minecraft.core.block.BlockFire;
-import net.minecraft.core.block.BlockFluid;
-import net.minecraft.core.block.BlockLanternFirefly;
-import net.minecraft.core.block.BlockJar;
-import net.minecraft.core.block.BlockSugarcane;
-import net.minecraft.core.block.BlockTallGrass;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.monster.MobZombiePig;
@@ -30,7 +30,7 @@ import java.util.ArrayList;
 import java.util.List;
 
 /**
- * Holds all the tags that can be applied to {@link net.minecraft.core.block.Block Block}.
+ * Holds all the tags that can be applied to {@link Block Block}.
  */
 public abstract class BlockTags
 {
@@ -38,146 +38,146 @@ public abstract class BlockTags
     /**
      * block can be mined by {@link ItemToolPickaxe ItemToolPickaxe}.
      */
-    public static Tag<Block> MINEABLE_BY_PICKAXE = Tag.of("mineable_by_pickaxe");
+    public static Tag<Block<?>> MINEABLE_BY_PICKAXE = Tag.of("mineable_by_pickaxe");
     /**
      * block can be mined by {@link ItemToolAxe ItemToolAxe}.
      */
-    public static Tag<Block> MINEABLE_BY_AXE = Tag.of("mineable_by_axe");
+    public static Tag<Block<?>> MINEABLE_BY_AXE = Tag.of("mineable_by_axe");
     /**
      * block can be mined by {@link ItemToolShovel ItemToolShovel}.
      */
-    public static Tag<Block> MINEABLE_BY_SHOVEL = Tag.of("mineable_by_shovel");
+    public static Tag<Block<?>> MINEABLE_BY_SHOVEL = Tag.of("mineable_by_shovel");
     /**
      * block can be mined by {@link ItemToolHoe ItemToolHoe}.
      */
-    public static Tag<Block> MINEABLE_BY_HOE = Tag.of("mineable_by_hoe");
+    public static Tag<Block<?>> MINEABLE_BY_HOE = Tag.of("mineable_by_hoe");
     /**
      * block can be mined by {@link ItemToolSword ItemToolSword}.
      */
-    public static Tag<Block> MINEABLE_BY_SWORD = Tag.of("mineable_by_sword");
+    public static Tag<Block<?>> MINEABLE_BY_SWORD = Tag.of("mineable_by_sword");
     /**
      * block can be mined by {@link ItemToolShears ItemShears}.
      */
-    public static Tag<Block> MINEABLE_BY_SHEARS = Tag.of("mineable_by_shears");
+    public static Tag<Block<?>> MINEABLE_BY_SHEARS = Tag.of("mineable_by_shears");
     /**
      * derived block has the properties of water.
      */
-    public static Tag<Block> IS_WATER = Tag.of("is_water");
+    public static Tag<Block<?>> IS_WATER = Tag.of("is_water");
     /**
      * derived block has the properties of lava.
      */
-    public static Tag<Block> IS_LAVA = Tag.of("is_lava");
+    public static Tag<Block<?>> IS_LAVA = Tag.of("is_lava");
     /**
-     * {@link BlockFlower BlockFlower}-derived blocks can be placed on this block.
+     * {@link BlockLogicFlower BlockFlower}-derived blocks can be placed on this block.
      */
-    public static Tag<Block> GROWS_FLOWERS = Tag.of("grows_flowers");
+    public static Tag<Block<?>> GROWS_FLOWERS = Tag.of("grows_flowers");
     /**
-     * {@link BlockSugarcane BlockSugarcane} can be placed on this block.
+     * {@link BlockLogicSugarcane BlockSugarcane} can be placed on this block.
      */
-    public static Tag<Block> GROWS_SUGAR_CANE = Tag.of("grows_sugar_cane");
+    public static Tag<Block<?>> GROWS_SUGAR_CANE = Tag.of("grows_sugar_cane");
     /**
-     * {@link BlockCactus BlockCactus} can be placed on this block.
+     * {@link BlockLogicCactus BlockCactus} can be placed on this block.
      */
-    public static Tag<Block> GROWS_CACTI = Tag.of("grows_cacti");
+    public static Tag<Block<?>> GROWS_CACTI = Tag.of("grows_cacti");
     /**
      * {@link net.minecraft.core.world.generate.feature.tree.WorldFeatureTree WorldFeatureTree} and its variations can be placed on this block.
      */
-    public static Tag<Block> GROWS_TREES = Tag.of("grows_trees");
-    public static Tag<Block> GROWS_SPINIFEX = Tag.of("grows_spinifex");
+    public static Tag<Block<?>> GROWS_TREES = Tag.of("grows_trees");
+    public static Tag<Block<?>> GROWS_SPINIFEX = Tag.of("grows_spinifex");
     /**
-     * This block is destroyed when {@link BlockFluid BlockFluid}-derived blocks try to move into its space.
+     * This block is destroyed when {@link BlockLogicFluid BlockFluid}-derived blocks try to move into its space.
      */
-    public static Tag<Block> BROKEN_BY_FLUIDS = Tag.of("broken_by_fluids");
+    public static Tag<Block<?>> BROKEN_BY_FLUIDS = Tag.of("broken_by_fluids");
     /**
-     * The block can have other blocks placed "into" it, like how {@link BlockTallGrass BlockTallGrass} behaves.
+     * The block can have other blocks placed "into" it, like how {@link BlockLogicTallGrass BlockTallGrass} behaves.
      */
-    public static Tag<Block> PLACE_OVERWRITES = Tag.of("place_overwrites");
+    public static Tag<Block<?>> PLACE_OVERWRITES = Tag.of("place_overwrites");
     /**
      * Passive mobs can spawn on this block.
      */
-    public static Tag<Block> PASSIVE_MOBS_SPAWN = Tag.of("passive_mobs_spawn");
+    public static Tag<Block<?>> PASSIVE_MOBS_SPAWN = Tag.of("passive_mobs_spawn");
     /**
      * {@link MobFireflyCluster MobFireflyCluster} can spawn on this block.
      */
-    public static Tag<Block> FIREFLIES_CAN_SPAWN = Tag.of("fireflies_can_spawn");
+    public static Tag<Block<?>> FIREFLIES_CAN_SPAWN = Tag.of("fireflies_can_spawn");
     /**
-     * {@link BlockFence BlockFence} visually connects to this block.
+     * {@link BlockLogicFence BlockFence} visually connects to this block.
      */
-    public static Tag<Block> FENCES_CONNECT = Tag.of("fences_connect");
+    public static Tag<Block<?>> FENCES_CONNECT = Tag.of("fences_connect");
     /**
      * This block does <b>not</b> appear in the creative menu.
      */
-    public static Tag<Block> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
+    public static Tag<Block<?>> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
     /**
      * This block drops as if using a silk touch tool when broken by {@link ItemToolShears ItemShears}.
      */
-    public static Tag<Block> SHEARS_DO_SILK_TOUCH = Tag.of("shears_do_silk_touch");
+    public static Tag<Block<?>> SHEARS_DO_SILK_TOUCH = Tag.of("shears_do_silk_touch");
     /**
      * This block can be skated on using {@link net.minecraft.core.item.Items#ARMOR_BOOTS_ICESKATES ice skates}.
      */
-    public static Tag<Block> SKATEABLE = Tag.of("skateable");
+    public static Tag<Block<?>> SKATEABLE = Tag.of("skateable");
     /**
      * Detects grass surface blocks so that {@link CavesLargeFeature MapGenCaves} can replace any exposed dirt with grass once it has finished generating a surface cave.
      */
-    public static Tag<Block> CAVE_GEN_REPLACES_SURFACE = Tag.of("cave_gen_replaces_surface");
+    public static Tag<Block<?>> CAVE_GEN_REPLACES_SURFACE = Tag.of("cave_gen_replaces_surface");
     /**
      * Determines which blocks {@link CavesLargeFeature MapGenCaves} can cut through
      */
-    public static Tag<Block> CAVES_CUT_THROUGH = Tag.of("caves_cut_through");
+    public static Tag<Block<?>> CAVES_CUT_THROUGH = Tag.of("caves_cut_through");
     /**
-     * Blocks such as {@link BlockLanternFirefly BlockLanternFirefly} can hang off this block.
+     * Blocks such as {@link BlockLogicLanternFirefly BlockLanternFirefly} can hang off this block.
      */
-    public static Tag<Block> CAN_HANG_OFF = Tag.of("can_hang_off");
+    public static Tag<Block<?>> CAN_HANG_OFF = Tag.of("can_hang_off");
     /**
      * Blocks like snow layers play their own sound when walking in them, instead of the sound of the block below
      */
-    public static Tag<Block> OVERRIDE_STEPSOUND = Tag.of("override_stepsound");
+    public static Tag<Block<?>> OVERRIDE_STEPSOUND = Tag.of("override_stepsound");
     /**
-     * {@link BlockFenceChainlink BlockFenceChainlink} visually connects to this block.
+     * {@link BlockLogicFenceChainlink BlockFenceChainlink} visually connects to this block.
      */
-    public static Tag<Block> CHAINLINK_FENCES_CONNECT = Tag.of("chainlink_fences_connect");
+    public static Tag<Block<?>> CHAINLINK_FENCES_CONNECT = Tag.of("chainlink_fences_connect");
     /**
      * Prevent mobs from spawning inside these blocks. Used for blocks with no collision like rails and redstone components
      */
-    public static Tag<Block> PREVENT_MOB_SPAWNS = Tag.of("prevent_mob_spawns");
+    public static Tag<Block<?>> PREVENT_MOB_SPAWNS = Tag.of("prevent_mob_spawns");
     /**
-     * Block can be planted inside a {@link BlockJar JarBlock}
+     * Block can be planted inside a {@link BlockLogicJar JarBlock}
      */
-    public static Tag<Block> PLANTABLE_IN_JAR = Tag.of("plantable_in_jar");
+    public static Tag<Block<?>> PLANTABLE_IN_JAR = Tag.of("plantable_in_jar");
     /**
-     * Block allows fire to burn forever on it {@link BlockFire BlockFire}
+     * Block allows fire to burn forever on it {@link BlockLogicFire BlockFire}
      */
-    public static Tag<Block> INFINITE_BURN = Tag.of("infinite_burn");
+    public static Tag<Block<?>> INFINITE_BURN = Tag.of("infinite_burn");
     /**
      * Block is broken on contact with an {@link EntityBoat EntityBoat}
      */
-    public static Tag<Block> BOAT_BREAKS = Tag.of("boat_breaks");
+    public static Tag<Block<?>> BOAT_BREAKS = Tag.of("boat_breaks");
     /**
      * Block extends the range of a motion sensor's sight.
      */
-    public static Tag<Block> EXTENDS_MOTION_SENSOR_RANGE = Tag.of("extends_motion_sensor_range");
+    public static Tag<Block<?>> EXTENDS_MOTION_SENSOR_RANGE = Tag.of("extends_motion_sensor_range");
     /**
      * When broken, items go into the player's inventory immediately instead of being dropped
      */
-    public static Tag<Block> INSTANT_PICKUP = Tag.of("instant_pickup");
+    public static Tag<Block<?>> INSTANT_PICKUP = Tag.of("instant_pickup");
     /**
      * Sheep will follow the player if they are holding this block.
      */
-    public static Tag<Block> SHEEPS_FAVOURITE_BLOCK = Tag.of("sheeps_favourite_block");
+    public static Tag<Block<?>> SHEEPS_FAVOURITE_BLOCK = Tag.of("sheeps_favourite_block");
     /**
      * Pigs will follow the player if they are holding this block.
      */
-    public static Tag<Block> PIGS_FAVOURITE_BLOCK = Tag.of("pigs_favourite_block");
+    public static Tag<Block<?>> PIGS_FAVOURITE_BLOCK = Tag.of("pigs_favourite_block");
     /**
      * Nether mobs can spawn on this block {@link MobZombiePig MobZombiePig}}.
      */
-    public static Tag<Block> NETHER_MOBS_SPAWN = Tag.of("nether_mobs_spawn");
+    public static Tag<Block<?>> NETHER_MOBS_SPAWN = Tag.of("nether_mobs_spawn");
     /**
      * Will drop block when piston extends into it
      */
-    public static Tag<Block> PISTON_CRUSHING = Tag.of("piston_crushing");
+    public static Tag<Block<?>> PISTON_CRUSHING = Tag.of("piston_crushing");
 
-    public static List<Tag<Block>> TAG_LIST;
+    public static List<Tag<Block<?>>> TAG_LIST;
 
     static
     {
@@ -189,7 +189,7 @@ public abstract class BlockTags
             {
                 try
                 {
-                    TAG_LIST.add((Tag<Block>)field.get(null));
+                    TAG_LIST.add((Tag<Block<?>>)field.get(null));
                 }
                 catch (Exception e)
                 {
diff --git a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
index 312b89c88..f8250a653 100644
--- a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnace.java
@@ -16,50 +16,50 @@ public class LookupFuelFurnace {
 	}
 
 	protected void register() {
-		addFuelEntry(Blocks.PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.PLANKS_OAK_PAINTED.id, 300);
-		addFuelEntry(Blocks.STAIRS_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.STAIRS_PLANKS_PAINTED.id, 300);
-		addFuelEntry(Blocks.SLAB_PLANKS_OAK.id, 150);
-		addFuelEntry(Blocks.SLAB_PLANKS_PAINTED.id, 150);
-		addFuelEntry(Blocks.FENCE_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.FENCE_PLANKS_OAK_PAINTED.id, 300);
-		addFuelEntry(Blocks.FENCE_GATE_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id, 300);
-		addFuelEntry(Blocks.LADDER_OAK.id, 300);
-		addFuelEntry(Blocks.BOOKSHELF_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.CHEST_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.CHEST_PLANKS_OAK_PAINTED.id, 300);
-		addFuelEntry(Blocks.WORKBENCH.id, 300);
-		addFuelEntry(Blocks.PRESSURE_PLATE_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.TRAPDOOR_PLANKS_OAK.id, 300);
-		addFuelEntry(Blocks.TRAPDOOR_PLANKS_PAINTED.id, 300);
-
-		addFuelEntry(Blocks.LOG_OAK.id, 300);
-		addFuelEntry(Blocks.LOG_BIRCH.id, 300);
-		addFuelEntry(Blocks.LOG_PINE.id, 300);
-		addFuelEntry(Blocks.LOG_CHERRY.id, 300);
-		addFuelEntry(Blocks.LOG_OAK_MOSSY.id, 300);
-		addFuelEntry(Blocks.LOG_EUCALYPTUS.id, 300);
-		addFuelEntry(Blocks.LOG_THORN.id, 300);
-		addFuelEntry(Blocks.LOG_PALM.id, 300);
-
-		addFuelEntry(Blocks.SAPLING_OAK.id, 100);
-		addFuelEntry(Blocks.SAPLING_PINE.id, 100);
-		addFuelEntry(Blocks.SAPLING_BIRCH.id, 100);
-		addFuelEntry(Blocks.SAPLING_CHERRY.id, 100);
-		addFuelEntry(Blocks.SAPLING_EUCALYPTUS.id, 100);
-		addFuelEntry(Blocks.SAPLING_SHRUB.id, 100);
-		addFuelEntry(Blocks.SAPLING_OAK_RETRO.id, 100);
-		addFuelEntry(Blocks.SAPLING_CACAO.id, 100);
-		addFuelEntry(Blocks.SAPLING_THORN.id, 100);
-		addFuelEntry(Blocks.SAPLING_PALM.id, 100);
-		addFuelEntry(Blocks.DEADBUSH.id, 100);
-		addFuelEntry(Blocks.SPINIFEX.id, 100);
-
-		addFuelEntry(Blocks.BLOCK_COAL.id, 12800);
-		addFuelEntry(Blocks.BLOCK_CHARCOAL.id, 12800);
-		addFuelEntry(Blocks.BLOCK_NETHER_COAL.id, 25600);
+		addFuelEntry(Blocks.PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.PLANKS_OAK_PAINTED.id(), 300);
+		addFuelEntry(Blocks.STAIRS_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.STAIRS_PLANKS_PAINTED.id(), 300);
+		addFuelEntry(Blocks.SLAB_PLANKS_OAK.id(), 150);
+		addFuelEntry(Blocks.SLAB_PLANKS_PAINTED.id(), 150);
+		addFuelEntry(Blocks.FENCE_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.FENCE_PLANKS_OAK_PAINTED.id(), 300);
+		addFuelEntry(Blocks.FENCE_GATE_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id(), 300);
+		addFuelEntry(Blocks.LADDER_OAK.id(), 300);
+		addFuelEntry(Blocks.BOOKSHELF_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.CHEST_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.CHEST_PLANKS_OAK_PAINTED.id(), 300);
+		addFuelEntry(Blocks.WORKBENCH.id(), 300);
+		addFuelEntry(Blocks.PRESSURE_PLATE_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.TRAPDOOR_PLANKS_OAK.id(), 300);
+		addFuelEntry(Blocks.TRAPDOOR_PLANKS_PAINTED.id(), 300);
+
+		addFuelEntry(Blocks.LOG_OAK.id(), 300);
+		addFuelEntry(Blocks.LOG_BIRCH.id(), 300);
+		addFuelEntry(Blocks.LOG_PINE.id(), 300);
+		addFuelEntry(Blocks.LOG_CHERRY.id(), 300);
+		addFuelEntry(Blocks.LOG_OAK_MOSSY.id(), 300);
+		addFuelEntry(Blocks.LOG_EUCALYPTUS.id(), 300);
+		addFuelEntry(Blocks.LOG_THORN.id(), 300);
+		addFuelEntry(Blocks.LOG_PALM.id(), 300);
+
+		addFuelEntry(Blocks.SAPLING_OAK.id(), 100);
+		addFuelEntry(Blocks.SAPLING_PINE.id(), 100);
+		addFuelEntry(Blocks.SAPLING_BIRCH.id(), 100);
+		addFuelEntry(Blocks.SAPLING_CHERRY.id(), 100);
+		addFuelEntry(Blocks.SAPLING_EUCALYPTUS.id(), 100);
+		addFuelEntry(Blocks.SAPLING_SHRUB.id(), 100);
+		addFuelEntry(Blocks.SAPLING_OAK_RETRO.id(), 100);
+		addFuelEntry(Blocks.SAPLING_CACAO.id(), 100);
+		addFuelEntry(Blocks.SAPLING_THORN.id(), 100);
+		addFuelEntry(Blocks.SAPLING_PALM.id(), 100);
+		addFuelEntry(Blocks.DEADBUSH.id(), 100);
+		addFuelEntry(Blocks.SPINIFEX.id(), 100);
+
+		addFuelEntry(Blocks.BLOCK_COAL.id(), 12800);
+		addFuelEntry(Blocks.BLOCK_CHARCOAL.id(), 12800);
+		addFuelEntry(Blocks.BLOCK_NETHER_COAL.id(), 25600);
 
 		addFuelEntry(Items.STICK.id, 100);
 
diff --git a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java
index d47da7159..d79297b77 100644
--- a/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/crafting/LookupFuelFurnaceBlast.java
@@ -13,8 +13,8 @@ public class LookupFuelFurnaceBlast extends LookupFuelFurnace {
 
 	@Override
 	protected void register() {
-		addFuelEntry(Blocks.BLOCK_NETHER_COAL.id, 12800);
-		addFuelEntry(Blocks.BLOCK_OLIVINE.id, 1600);
+		addFuelEntry(Blocks.BLOCK_NETHER_COAL.id(), 12800);
+		addFuelEntry(Blocks.BLOCK_OLIVINE.id(), 1600);
 
 		addFuelEntry(Items.NETHERCOAL.id, 1600);
 		addFuelEntry(Items.OLIVINE.id, 200);
diff --git a/game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java b/game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
index e795341fe..c2442ba8e 100644
--- a/game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
+++ b/game/core/src/main/java/net/minecraft/core/data/gamerule/TreecapitatorHelper.java
@@ -6,8 +6,8 @@ import java.util.List;
 import java.util.Set;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockLeavesBase;
-import net.minecraft.core.block.BlockLog;
+import net.minecraft.core.block.BlockLogicLeavesBase;
+import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.player.Player;
@@ -133,12 +133,10 @@ public class TreecapitatorHelper {
 		// Break leaves
 		for(int i=0; i < allBlocksList.size(); i++) {
 			ChunkPosition pos = allBlocksList.get(i);
-			Block block = world.getBlock(pos.x, pos.y, pos.z);
-			if(block instanceof BlockLeavesBase) {
-				BlockLeavesBase blockLeaves = (BlockLeavesBase) block;
-				
+			Block<?> block = world.getBlock(pos.x, pos.y, pos.z);
+			if(block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
 				if(player.getGamemode().dropBlockOnBreak()) {
-					ItemStack[] drops = blockLeaves.getBreakResult(world, EnumDropCause.PROPER_TOOL, pos.x, pos.y, pos.z, world.getBlockMetadata(pos.x, pos.y, pos.z), null);
+					ItemStack[] drops = block.getBreakResult(world, EnumDropCause.PROPER_TOOL, pos.x, pos.y, pos.z, world.getBlockMetadata(pos.x, pos.y, pos.z), null);
 					if(itemList != null) {
 						itemList.addAll(drops);
 					}else {
@@ -196,7 +194,7 @@ public class TreecapitatorHelper {
 	}
 	
 	protected boolean breakBlock(ChunkPosition pos, boolean particle, ItemList itemList) {
-		Block block = world.getBlock(pos.x, pos.y, pos.z);
+		Block<?> block = world.getBlock(pos.x, pos.y, pos.z);
 		if(world.setBlockWithNotify(pos.x, pos.y, pos.z, 0)) {
 			int meta = world.getBlockMetadata(pos.x, pos.y, pos.z);
 			ItemStack[] drops = block.getBreakResult(world, EnumDropCause.PROPER_TOOL, pos.x, pos.y, pos.z, meta, null);
@@ -208,22 +206,22 @@ public class TreecapitatorHelper {
 				}	
 			}
 			if(particle) {
-				world.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, pos.x, pos.y, pos.z, block.id);
+				world.playBlockEvent(player, LevelListener.EVENT_BLOCK_BREAK, pos.x, pos.y, pos.z, block.id());
 			}
 			return true;
 		}
 		return false;
 	}
 	
-	protected boolean isLog(Block block) {
-		return block instanceof BlockLog;
+	protected boolean isLog(Block<?> block) {
+		return block != null && block.getLogic() instanceof BlockLogicLog;
 	}
 	
 	protected boolean isDecayableLeaf(ChunkPosition pos) {
-		Block block = world.getBlock(pos.x, pos.y, pos.z);
-		if(block instanceof BlockLeavesBase) {
+		Block<?> block = world.getBlock(pos.x, pos.y, pos.z);
+		if(block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
 			int meta = world.getBlockMetadata(pos.x, pos.y, pos.z);
-			if(BlockLeavesBase.isPermanent(meta)) {
+			if(BlockLogicLeavesBase.isPermanent(meta)) {
 				return false;
 			}
 			
@@ -264,10 +262,10 @@ public class TreecapitatorHelper {
 			for (int offX = -range; offX <= range; offX++) {
 				for (int offY = -range; offY <= range; offY++) {
 					for (int offZ = -range; offZ <= range; offZ++) {
-						Block block = world.getBlock(x + offX, y + offY, z + offZ);
+						Block<?> block = world.getBlock(x + offX, y + offY, z + offZ);
 						if(isLog(block)) {
 							adjacentTreeBlocks[(offX + b) * a + (offY + b) * byte1 + (offZ + b)] = 0;
-						}else if(block instanceof BlockLeavesBase) {
+						}else if(block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
 							adjacentTreeBlocks[(offX + b) * a + (offY + b) * byte1 + (offZ + b)] = -2;
 						} else {
 							adjacentTreeBlocks[(offX + b) * a + (offY + b) * byte1 + (offZ + b)] = -1;
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
index 2540a7826..889b19ca9 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/Registries.java
@@ -138,7 +138,7 @@ public class Registries extends Registry<Registry<?>>
         ArrayList<ItemStack> list = new ArrayList<>();
         for (Object item : items) {
             if (item instanceof Block) {
-                list.add(new ItemStack((Block) item));
+                list.add(new ItemStack((Block<?>) item));
             } else if (item instanceof Item) {
                 list.add(new ItemStack((Item) item));
             } else if (item instanceof ItemStack) {
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
index 736695519..daba7734f 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/RecipeRegistry.java
@@ -214,7 +214,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
             } else
             if(aobj[i + 1] instanceof Block)
             {
-                recipeSymbol = new RecipeSymbol(character,new ItemStack((Block)aobj[i + 1]),null);
+                recipeSymbol = new RecipeSymbol(character,new ItemStack((Block<?>)aobj[i + 1]),null);
             } else
             if(aobj[i + 1] instanceof ItemStack)
             {
@@ -284,7 +284,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
             } else
             if(aobj[i + 1] instanceof Block)
             {
-                recipeSymbol = new RecipeSymbol(character,new ItemStack((Block)aobj[i + 1]),null);
+                recipeSymbol = new RecipeSymbol(character,new ItemStack((Block<?>)aobj[i + 1]),null);
             } else
             if(aobj[i + 1] instanceof ItemStack)
             {
@@ -348,7 +348,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
             }else if(obj instanceof Item) {
                 list.add(new RecipeSymbol('\0', new ItemStack((Item) obj),null));
             }else if(obj instanceof Block) {
-                list.add(new RecipeSymbol('\0', new ItemStack((Block) obj),null));
+                list.add(new RecipeSymbol('\0', new ItemStack((Block<?>) obj),null));
             } else if (obj instanceof String) {
                 list.add(new RecipeSymbol('\0', null, (String) obj));
             } else {
@@ -370,7 +370,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         }else if(input instanceof Item) {
             symbol = new RecipeSymbol('\0', new ItemStack((Item) input),null);
         }else if(input instanceof Block) {
-            symbol = new RecipeSymbol('\0', new ItemStack((Block) input),null);
+            symbol = new RecipeSymbol('\0', new ItemStack((Block<?>) input),null);
         } else if (input instanceof String) {
             symbol = new RecipeSymbol('\0', null, (String) input);
         } else {
@@ -390,7 +390,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         }else if(input instanceof Item) {
             symbol = new RecipeSymbol('\0', new ItemStack((Item) input),null);
         }else if(input instanceof Block) {
-            symbol = new RecipeSymbol('\0', new ItemStack((Block) input),null);
+            symbol = new RecipeSymbol('\0', new ItemStack((Block<?>) input),null);
         } else if (input instanceof String) {
             symbol = new RecipeSymbol('\0', null, (String) input);
         } else {
@@ -410,7 +410,7 @@ public class RecipeRegistry extends Registry<RecipeNamespace> {
         }else if(input instanceof Item) {
             symbol = new RecipeSymbol('\0', new ItemStack((Item) input),null);
         }else if(input instanceof Block) {
-            symbol = new RecipeSymbol('\0', new ItemStack((Block) input),null);
+            symbol = new RecipeSymbol('\0', new ItemStack((Block<?>) input),null);
         } else if (input instanceof String) {
             symbol = new RecipeSymbol('\0', null, (String) input);
         } else {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 8f5c71d20..7bf09ecd0 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -3,7 +3,7 @@ package net.minecraft.core.entity;
 import java.util.List;
 import java.util.Random;
 
-import net.minecraft.core.block.BlockFluid;
+import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DyeColor;
@@ -597,13 +597,13 @@ public abstract class Entity
             int blockX = MathHelper.floor(this.x);
             int blockY = MathHelper.floor(boundingBox.minY);
             int blockZ = MathHelper.floor(this.z);
-            
-            Block blockWalkedOn = null;
+
+            Block<?> blockWalkedOn = null;
 
             blockCheck: for (int x = blockX - 1; x <= blockX + 1; x++) {
                 for (int z = blockZ - 1; z <= blockZ + 1; z++) {
                     for (int y = blockY - 1; y < blockY + 1; y++) {
-                        Block block = world.getBlock(x, y, z);
+                        Block<?> block = world.getBlock(x, y, z);
                         if(block == null) {
                             continue;
                         }
@@ -624,7 +624,7 @@ public abstract class Entity
             
             // Check for snow layers
             int blockYUp = MathHelper.floor(boundingBox.maxY);
-            Block blockAbove = world.getBlock(blockX, blockYUp, blockZ);
+            Block<?> blockAbove = world.getBlock(blockX, blockYUp, blockZ);
             if(blockAbove != null && blockAbove.hasTag(BlockTags.OVERRIDE_STEPSOUND)) {
             	blockWalkedOn = blockAbove;
             	blockY = blockYUp;
@@ -780,9 +780,9 @@ public abstract class Entity
         int j = MathHelper.floor_float(MathHelper.floor(d));
         int k = MathHelper.floor(z);
         int l = world.getBlockId(i, j, k);
-        if(l != 0 && Blocks.blocksList[l].blockMaterial == material)
+        if(l != 0 && Blocks.blocksList[l].getMaterial() == material)
         {
-            float f = BlockFluid.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
+            float f = BlockLogicFluid.getWaterVolume(world.getBlockMetadata(i, j, k)) - 0.2F;
             float f1 = (float)(j + 1) - f;
             return d < (double)f1;
         } else
@@ -943,7 +943,7 @@ public abstract class Entity
         return true;
     }
 
-    public boolean collidesWithBlock(Block block, int metadata) {
+    public boolean collidesWithBlock(Block<?> block, int metadata) {
         return true;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
index 22a1a068d..953aa3d2e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFallingBlock.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.entity;
 
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockSand;
+import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityDispatcher;
@@ -78,7 +78,7 @@ public class EntityFallingBlock extends Entity
         if (pushTime < 0.05f || (pushTime < 0.25 && onGround)){
             pushTime = 0;
         }
-        if (isOnFire() && carriedBlock.blockId == Blocks.TNT.id) {
+        if (isOnFire() && carriedBlock.blockId == Blocks.TNT.id()) {
             remove();
             EntityPrimedTNT entityPrimedTNT = new EntityPrimedTNT(world, x, y, z);
             entityPrimedTNT.xd = this.xd;
@@ -108,8 +108,8 @@ public class EntityFallingBlock extends Entity
             hasRemovedBlock = true;
         }
         if (onGround) {
-            Block selfBlock = carriedBlock.block();
-            Block blockBelow = world.getBlock(x, y - 1, z);
+            Block<?> selfBlock = carriedBlock.block();
+            Block<?> blockBelow = world.getBlock(x, y - 1, z);
             double friction = selfBlock.friction;
             friction *= blockBelow == null ? 0.98 : blockBelow.friction * 0.91f;
             xd *= friction;
@@ -125,7 +125,7 @@ public class EntityFallingBlock extends Entity
                 Entity rider = getPassenger();
                 ejectRider();
                 remove();
-                if((!world.canBlockBePlacedAt(carriedBlock.blockId, x, y, z, true, Side.TOP) || BlockSand.canFallBelow(world, x, y - 1, z) || !world.setBlock(x, y, z, carriedBlock.blockId)) && !world.isClientSide)
+                if((!world.canBlockBePlacedAt(carriedBlock.blockId, x, y, z, true, Side.TOP) || BlockLogicSand.canFallBelow(world, x, y - 1, z) || !world.setBlock(x, y, z, carriedBlock.blockId)) && !world.isClientSide)
                 {
                     if(hasRemovedBlock) {
                         drop();
@@ -164,7 +164,7 @@ public class EntityFallingBlock extends Entity
     }
 
     public void drop() {
-        Block block = carriedBlock.block();
+        Block<?> block = carriedBlock.block();
         if (block != null) {
             ItemStack[] drops = block.getBreakResult(world, EnumDropCause.SILK_TOUCH, carriedBlock.metadata, carriedBlock.entity);
             if (drops != null && drops.length > 0) {
